Index: squid/src/structs.h
diff -u squid/src/structs.h:1.1.1.2 squid/src/structs.h:1.1.1.2.10.1
--- squid/src/structs.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/structs.h	Fri Nov 10 10:44:53 2000
@@ -1,4 +1,7 @@
-
+#define MMAPSTORE	/*srb*/
+#define NEVERFREE
+#define SSPOOLS
+#define HPL_REPL	1
 /*
  * $Id: squid-bugless-2_2-s2_2,v 1.2 2004/09/29 00:22:50 hno Exp $
  *
@@ -231,6 +234,13 @@
 	int pct;
 	size_t max;
     } quickAbort;
+#ifdef	HPL_REPL
+    char * replPolicy;
+#endif	/* HPL_REPL */
+    /* 
+     * Note: the non-LRU policies do not use referenceAge, but we cannot
+     * remove it until we find out how to implement #else for cf_parser.c
+     */
     time_t referenceAge;
     time_t negativeTtl;
     time_t negativeDnsTtl;
@@ -253,6 +263,7 @@
     size_t maxRequestSize;
     struct {
 	ushortlist *http;
+	ushort bhttp;
 	u_short icp;
 #if USE_HTCP
 	u_short htcp;
@@ -1195,15 +1206,30 @@
 #endif
 };
 
+#ifdef	HPL_REPL
+#include "heap.h"
+#endif	/* HPL_REPL */
 
 /* This structure can be freed while object is purged out from memory */
 struct _MemObject {
-    method_t method;
     char *url;
+    store_client *clients;
+#if HPL_REPL
+    /* 
+     * A MemObject knows where it is in the in-memory heap.
+     */
+    union {
+     heap_node ode;
+     struct _MemObject *ext;
+    } n;
+    StoreEntry *entry;
+#else	/* HPL_REPL */
+    dlink_node lru;
+#endif	/* HPL_REPL */
+    method_t method;
     mem_hdr data_hdr;
     off_t inmem_hi;
     off_t inmem_lo;
-    store_client *clients;
     int nclients;
     struct {
 	off_t queue_offset;	/* relative to in-mem data */
@@ -1222,17 +1248,51 @@
 	void *data;
     } abort;
     char *log_url;
-    dlink_node lru;
     int id;
     ssize_t object_sz;
     size_t swap_hdr_sz;
 };
 
+#ifdef MMAPSTORE
+#define Skey			s->key
+#define Stimestamp		s->timestamp
+#define Slastref		s->lastref
+#define Sexpires		s->expires
+#define Slastmod		s->lastmod
+#define Sswap_file_sz		s->swap_file_sz
+#define Srefcount		s->refcount
+#define Sflag			s->flags
+#define Sswap_file_number	s->swap_file_number
+#else
+#define Skey			key
+#define Stimestamp		timestamp
+#define Slastref		lastref
+#define Sexpires		expires
+#define Slastmod		lastmod
+#define Sswap_file_sz		swap_file_sz
+#define Srefcount		refcount
+#define Sflag			flags
+#define Sswap_file_number	swap_file_number
+#endif
+
 struct _StoreEntry {
     /* first two items must be same as hash_link */
+#ifdef MMAPSTORE
+    storeSwapLogData *s;
+#else
     const cache_key *key;
-    StoreEntry *next;
+#endif
+    StoreEntry *next;		/* for the hash table */
+#ifdef	HPL_REPL
+    union {
+     heap_node ode;
+     StoreEntry *ext;
+    } n;
+#else	/* HPL_REPL */
+    dlink_node lru;
+#endif	/* HPL_REPL */
     MemObject *mem_obj;
+#ifndef MMAPSTORE
     time_t timestamp;
     time_t lastref;
     time_t expires;
@@ -1241,7 +1301,7 @@
     u_short refcount;
     u_short flags;
     int swap_file_number;
-    dlink_node lru;
+#endif
     u_short lock_count;		/* Assume < 65536! */
     mem_status_t mem_status:3;
     ping_status_t ping_status:3;
@@ -1249,14 +1309,31 @@
     swap_status_t swap_status:3;
 };
 
+#ifdef MMAPSTORE
+struct mmapinfo {
+    storeSwapLogData*mmapbase,*mmapend,*mmapmax,*mmapfreelist;
+    char*path;
+    struct mmapinfo*next;
+};
+#endif
+
 struct _SwapDir {
+#ifdef MMAPSTORE
+    struct mmapinfo*mi;
+#endif
     char *path;
     int l1;
     int l2;
+    int low_size;
     int cur_size;
+    int win_size;
     int max_size;
     int suggest;
     fileMap *map;
+#if HPL_REPL
+    heap_p heap;
+    unsigned riddance;
+#endif
     int swaplog_fd;
     struct {
 	unsigned int selected:1;
@@ -1518,16 +1595,18 @@
 };
 
 struct _storeSwapLogData {
-    char op;
-    int swap_file_number;
+    unsigned char key[MD5_DIGEST_CHARS];
+    size_t swap_file_sz;
     time_t timestamp;
     time_t lastref;
     time_t expires;
     time_t lastmod;
-    size_t swap_file_sz;
     u_short refcount;
     u_short flags;
-    unsigned char key[MD5_DIGEST_CHARS];
+#ifndef MMAPSTORE
+    char op;
+#endif
+    int swap_file_number;
 };
 
 /* object to track per-action memory usage (e.g. #idle objects) */
@@ -1550,7 +1629,8 @@
 struct _MemPool {
     const char *label;
     size_t obj_size;
-    Stack pstack;		/* stack for free pointers */
+    void*pstack;		/* stack for free pointers */
+    struct _MemPool *ss;	/* same size free pool */
     MemPoolMeter meter;
 };
 
Index: squid/src/tools.c
diff -u squid/src/tools.c:1.1.1.2 squid/src/tools.c:1.1.1.2.10.1
--- squid/src/tools.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/tools.c	Fri Nov 10 10:44:53 2000
@@ -216,7 +216,10 @@
 {
     struct rusage rusage;
     squid_getrusage(&rusage);
-    fprintf(debug_log, "CPU Usage: %.3f seconds\n", rusage_cputime(&rusage));
+    fprintf(debug_log, "CPU Usage: %.3f seconds = %.3f user + %.3f sys\n",
+	    rusage_cputime(&rusage), 
+	    rusage.ru_utime.tv_sec + ((double) rusage.ru_utime.tv_usec / 1000000.0),
+	    rusage.ru_stime.tv_sec + ((double) rusage.ru_stime.tv_usec / 1000000.0));
     fprintf(debug_log, "Maximum Resident Size: %d KB\n",
 	rusage_maxrss(&rusage));
     fprintf(debug_log, "Page faults with physical i/o: %d\n",
@@ -262,7 +265,9 @@
     releaseServerSockets();
     storeDirWriteCleanLogs(0);
     PrintRusage();
+#if 0 /* srb prevent deadlocks */
     dumpMallocStats();
+#endif
     if (squid_curtime - SQUID_RELEASE_TIME < 864000) {
 	/* skip if more than 10 days old */
 	if (Config.adminEmail)
Index: squid/src/url.c
diff -u squid/src/url.c:1.1.1.2 squid/src/url.c:1.1.1.2.10.1
--- squid/src/url.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/url.c	Fri Nov 10 10:44:53 2000
@@ -241,7 +241,7 @@
     /* remove trailing dots from hostnames */
     while ((l = strlen(host)) > 0 && host[--l] == '.')
 	host[l] = '\0';
-    if (Config.appendDomain && !strchr(host, '.'))
+    if (Config.appendDomain && *host && !strchr(host, '.'))
 	strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN);
     if (port == 0) {
 	debug(23, 3) ("urlParse: Invalid port == 0\n");
Index: squid/src/urn.c
diff -u squid/src/urn.c:1.1.1.2 squid/src/urn.c:1.1.1.2.10.1
--- squid/src/urn.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/urn.c	Fri Nov 10 10:44:53 2000
@@ -187,7 +187,7 @@
     int urlcnt = 0;
 
     debug(52, 3) ("urnHandleReply: Called with size=%d.\n", size);
-    if (EBIT_TEST(urlres_e->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(urlres_e->Sflag, ENTRY_ABORTED)) {
 	memFree(buf, MEM_4K_BUF);
 	return;
     }
Index: squid/src/wais.c
diff -u squid/src/wais.c:1.1.1.2 squid/src/wais.c:1.1.1.2.28.1
--- squid/src/wais.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/wais.c	Fri Nov 10 10:44:53 2000
@@ -93,7 +93,7 @@
 #if DELAY_POOLS
     delay_id delay_id = delayMostBytesAllowed(entry->mem_obj);
 #endif
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(fd);
 	return;
     }
@@ -130,7 +130,7 @@
 		waisReadReply, waisState, 0);
 	} else {
 	    ErrorState *err;
-	    EBIT_CLR(entry->flags, ENTRY_CACHABLE);
+	    EBIT_CLR(entry->Sflag, ENTRY_CACHABLE);
 	    storeReleaseRequest(entry);
 	    err = errorCon(ERR_READ_ERROR, HTTP_INTERNAL_SERVER_ERROR);
 	    err->xerrno = errno;
@@ -147,7 +147,7 @@
 	comm_close(fd);
     } else if (len == 0) {
 	/* Connection closed; retrieval done. */
-	entry->expires = squid_curtime;
+	entry->Sexpires = squid_curtime;
 	fwdComplete(waisState->fwd);
 	comm_close(fd);
     } else {
@@ -211,9 +211,9 @@
     memBufPrintf(&mb, "\r\n");
     debug(24, 6) ("waisSendRequest: buf: %s\n", mb.buf);
     comm_write_mbuf(fd, mb, waisSendComplete, waisState);
-    if (EBIT_TEST(waisState->entry->flags, ENTRY_CACHABLE))
+    if (EBIT_TEST(waisState->entry->Sflag, ENTRY_CACHABLE))
 	storeSetPublicKey(waisState->entry);	/* Make it public */
-    EBIT_CLR(waisState->entry->flags, ENTRY_FWD_HDR_WAIT);
+    EBIT_CLR(waisState->entry->Sflag, ENTRY_FWD_HDR_WAIT);
 }
 
 void
